<?php
namespace Admin\Controller;

use Admin\Model\SettingModel;
use Common\Controller\AdminController;
use Niaoyun\Api\CloudApi;
use Niaoyun\Common\Email;
use Niaoyun\Host\HostDbLog;
use Niaoyun\Host\HostLog;
use Niaoyun\Host\HostServerAttr;
use Niaoyun\Hostdb\HostdbServerAttr;
use Niaoyun\NewConfig;
use Niaoyun\Admin\AdminLog;
use Niaoyun\Setting\Setting;

class SettingController extends AdminController
{
    private $settingModel;

    public function _initialize()
    {
        parent::_initialize();
        $this->settingModel = D('Setting');
        /*
        $integralValue = $this->settingModel->where(['key' => 'integral'])->getField('value');
        $integralValue = json_decode(base64_decode($integralValue), true);
        $this->integralService = explode(',', $integralValue['integralService']);
        */

        /*
        $rechargeValue = $this->settingModel->where(['key' => 'recharge'])->getField('value');
        $financeValue = $this->settingModel->where(['key' => 'finance'])->getField('value');
        $contractValue = $this->settingModel->where(['key' => 'contract'])->getField('value');
        $productValue = $this->settingModel->where(['key' => 'product'])->getField('value');
        $emailValue = $this->settingModel->where(['key' => 'email'])->getField('value');
        $interfaceValue = C('interface');

        $safetyValue = $this->settingModel->where(['key' => 'safety'])->getField('value');
        $uploadValue = $this->settingModel->where(['key' => 'upload'])->getField('value');
        $pushValue = $this->settingModel->where(['key' => 'push'])->getField('value');
        $workorderValue = $this->settingModel->where(['key' => 'workorder'])->getField('value');
        $smgValue = $this->settingModel->where(['key' => 'smg'])->getField('value');//短信接口信息
        */


        /*
                $basicValue = $this->settingModel->where(['key' => 'basic'])->getField('value');
                $memberValue = $this->settingModel->where(['key' => 'member'])->getField('value');
                $this->assign('basic', json_decode(base64_decode($basicValue), true));
                $this->assign('member', json_decode(base64_decode($memberValue), true));
                $this->assign('integral', $integralValue);
                $this->assign('recharge', json_decode(base64_decode($rechargeValue), true));
                $this->assign('finance', json_decode(base64_decode($financeValue), true));
                $this->assign('contract', json_decode(base64_decode($contractValue), true));
                $this->assign('product', json_decode(base64_decode($productValue), true));
                $this->assign('email', json_decode(base64_decode($emailValue), true));
                $this->assign('smg', json_decode(base64_decode($smgValue), true));
                $this->assign('safety', json_decode(base64_decode($safetyValue), true));
                $this->assign('upload', json_decode(base64_decode($uploadValue), true));
                $this->assign('push', json_decode(base64_decode($pushValue), true));
                $this->assign('workorder', json_decode(base64_decode($workorderValue), true));*/
    }

    private function verifyTemplate($home, $admin, $user)
    {
        $n1 = checkThemeTemplateName($home);
        $n2 = checkThemeTemplateName($admin);
        $n3 = checkThemeTemplateName($user);

        //验证模板是否存在
        $t1 = themeExists('themeHome', $home);
        $t2 = themeExists('themeUser', $user);
        $t3 = themeExists('themeAdmin', $admin);

        return $n1 && $n2 && $n3 && $t1 && $t2 && $t3;
    }

    /**
     * 设置保存
     *
     * @param string $module        模块(暂时定义为位置)
     * @param int    $section       作用区域
     * @param string $setConfigData 设置内容
     */
    private function setConfig($module = '', $section = 1, $setConfigData, $title = '', $log = '')
    {
        $config = new NewConfig($module, $section, ROOT_PATH . 'config', 'config.php');
        $result = $config->add_config($setConfigData);
//        $key = key($setConfigData);//临时性解决办法，key 构造数据可制造bug，不严谨
        if ($result) {
            AdminLog::saveLog(AdminLog::globalsystem, '', '设置' . $title . '成功', json_encode($log));
            $this->ajaxReturn(['result' => true, 'text' => '保存成功']);
        } else {
            AdminLog::saveLog(AdminLog::globalsystem, '', '设置' . $title . '失败', json_encode($log));
            $this->ajaxReturn(['result' => false, 'text' => '保存失败']);
        }
    }

    public function index()
    {
        $themeHome = getTemplateNames('themeHome');
        $themeUser = getTemplateNames('themeUser');
        $themeAdmin = getTemplateNames('themeAdmin');

        $smsConfig = require ROOT_CONFIG_PATH . 'smsConfig.php';
        foreach ($smsConfig as $channel => $value) {
            $smsLists[$channel] = $value['channelName'];
        }

        $this->assign('smsLists', $smsLists);
        $this->assign('themeHome', $themeHome);
        $this->assign('themeUser', $themeUser);
        $this->assign('themeAdmin', $themeAdmin);
        $this->assign('currThemeHome', getCurrThemeName('themeHome'));
        $this->assign('currThemeUser', getCurrThemeName('themeUser'));
        $this->assign('currThemeAdmin', getCurrThemeName('themeAdmin'));

        //上传地址不存在时默认展示当前域名
        $upload_url = SITE_DOMAIN . '/';

        $this->assign('uploadUrl', $upload_url);
        $this->assign('integral', C('integral'));
        $this->assign('interface', C('interface'));
        $this->assign('basic', C('basic'));
        $this->assign('member', C('member'));

        $groupList = M('cashcoupon_group')->field('id,name')->where("status = '1'")->order('sortID asc')->select();
        $this->assign('cashcoupon_group_lists', $groupList);

        //查询虚拟主机控制面板
        $hostPanel = HostServerAttr::getHostPanel();
        $this->assign('hostPanel', $hostPanel);
        //查询数据库控制面板
        $dbPanel = HostdbServerAttr::getDbPanel();
        $this->assign('dbPanel', $dbPanel);
        $this->assign('integral', C('integral'));
        $this->assign('integralService', explode(',', C('integral.integralService')));
        $this->assign('recharge', C('recharge'));
        $this->assign('finance', C('finance'));
        $this->assign('contract', C('contract'));
        $this->assign('product', C('product'));
        $this->assign('email', C('email'));
        $this->assign('smg', C('smg'));
        $this->assign('safety', C('safety'));
        $this->assign('upload', C('upload'));
        $this->assign('push', C('push'));
        $this->assign('workorder', C('workorder'));
        $this->assign('promotion', C('promotion'));

        $this->display('basic');
    }

    /**
     * 基本设置
     */
    public function basic()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);
            // 验证模板数据
            $themeHome = I('themeHome');
            $themeUser = I('themeUser');
            $themeAdmin = I('themeAdmin');
            if (!$this->verifyTemplate($themeHome, $themeAdmin, $themeUser)) {
                $this->ajaxReturn(['result' => false, 'text' => '模板参数异常']);
            }

            if (!$this->settingModel->validate(SettingModel::$rules['basic'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $configData['basic'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }

            $this->setConfig('', 1, $configData, '基本', $log);
        }
        // $this->display();
    }

    /**
     * 会员设置
     */
    public function member()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);
            $_POST['enableUnlock'] = implode(',', $_POST['enableUnlock']);
            $_POST['loginWay'] = implode(',', $_POST['loginWay']);
            $_POST['cashCouponScene'] = implode(',', $_POST['cashCouponScene']);
            $post = I('post.');
            if ($post['registerCashCoupon'] > 0) {
                if (!$post['cashCouponGroupID']) {
                    $this->ajaxReturn(['result' => false, 'text' => '请选择现金券组！']);
                }
                if (trim($post['cashCouponMaxTimes']) == '') {
                    $this->ajaxReturn(['result' => false, 'text' => '注册赠送现金券使用次数必填！']);
                }

                if ($post['cashCouponMaxTimes'] >= 100) {
                    $this->ajaxReturn(['result' => false, 'text' => '注册赠送现金券使用次数必填小于100！']);
                }
                 if (!$post['registerCashCouponDays']) {
                    $this->ajaxReturn(['result' => false, 'text' => '注册赠送现金券有效期必填！']);
                }
                if (!$post['cashCouponScene']) {
                    $this->ajaxReturn(['result' => false, 'text' => '注册赠送现金券使用场景必填！']);
                }
            }

			$newVerifyMaxFreeNum = I('post.newVerifyMaxFreeNum');
			$newVerifyMaxNum = I('post.newVerifyMaxNum');

			if( $newVerifyMaxFreeNum > $newVerifyMaxNum ){
				$this->ajaxReturn(['result' => false, 'text' => '最大免费认证次数，不可大于认证次数！']);
			}

            if (!$this->settingModel->validate(SettingModel::$rules['member'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }
            $configData['member'] = base64_encode(json_encode(I('post.')));
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '会员', $log);
        }
    }

    /**
     * 工单设置
     */
    public function workorder()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            $_POST['noticeCondition'] = implode(',', $_POST['noticeCondition']);


            if (!$this->settingModel->validate(SettingModel::$rules['workorder'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }
            $configData['workorder'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '工单', $log);
        }
    }

    /**
     * 积分设置
     */
    public function integral()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);
            $result = [
                ['presentedSwitch', [0, 1], '赠送开关取值不正确！', 1, 'in'],
                ['proportionIntegral', 'checkPosNumeric', '积分比例格式不正确！', 2, 'function'],
                ['integralBeginTime', 'checkDateTime', '积分开始时间格式不正确！', 2, 'function'],
                ['integralEndTime', 'checkDateTime', '积分结束时间格式不正确！', 2, 'function'],
                //['personIdentification', 'checkPosIntZ', '个人认证赠送积分格式不正确！', 2, 'function'],
                //['companyIdentification', 'checkPosIntZ', '企业认证赠送积分格式不正确！', 2, 'function'],
                ['integralService', 'checkIntegralService', '赠送积分业务格式不正确！', 2, 'callback'],
                ['integralName', '/^[\x{4e00}-\x{9fa5}]{2,4}$/u', '积分名称格式不正确！', 1],
            ];

            $post = I('post.');
            if ($post['presentedSwitch'] == 0) {
                $_POST['integralService'] = implode(',', $_POST['integralService']);
                if (!$this->settingModel->validate($result)->create()) {
                    if ($this->settingModel->getError()) {
                        $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                    }
                }

                $configData['integral'] = base64_encode(json_encode(I('post.')));
                $log = '';
                if (!empty($post)) {
                    foreach ($post as $key => $p) {
                        $s_key = Setting::getSetting($key);
                        $log[$s_key] = $p;
                    }
                }
                $this->setConfig('', 1, $configData, '积分', $log);
            } else {
                if (empty($post['integralBeginTime'])) {
                    $this->ajaxReturn(['result' => false, 'text' => '积分开始时间不能为空']);
                }
                if (empty($post['integralEndTime'])) {
                    $this->ajaxReturn(['result' => false, 'text' => '积分结束时间不能为空']);
                }

                if (strtotime($post['integralBeginTime']) > strtotime($post['integralEndTime'])) {
                    $this->ajaxReturn(['result' => false, 'text' => '积分开始时间不能大于积分结束时间']);
                }

                $_POST['integralService'] = implode(',', $_POST['integralService']);
                if (!$this->settingModel->validate(SettingModel::$rules['integral'])->create()) {
                    if ($this->settingModel->getError()) {
                        $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                    }
                }

                $configData['integral'] = base64_encode(json_encode(I('post.')));
                $log = '';
                if (!empty($post)) {
                    foreach ($post as $key => $p) {
                        $s_key = Setting::getSetting($key);
                        $log[$s_key] = $p;
                    }
                }
                $this->setConfig('', 1, $configData, '积分', $log);
            }
        }
    }

    /**
     * 财务设置
     */
    public function finance()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['finance'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }
            $configData['finance'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '财务', $log);
        }
    }

    /**
     * 充值设置
     */
    public function recharge()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);
            if (!$this->settingModel->validate(SettingModel::$rules['recharge'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $configData['recharge'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '充值', $log);
        }
    }

    /**
     * 合同设置
     */
    public function contract()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['contract'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $configData['contract'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    if ($key != 'postcode') {
                        $s_key = Setting::getSetting($key);
                        $log[$s_key] = $p;
                    } else {
                        $s_key = Setting::getSetting('postcode2');
                        $log[$s_key] = $p;
                    }

                }
            }
            $this->setConfig('', 1, $configData, '合同', $log);
        }
    }

    /**
     * 产品设置
     */
    public function product()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['product'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }


	        $post_data = I('post.');
            //异常 ip 通知方式，如果没有，默认就是no
            if( $post_data['ip_exception_mobile_notify']!='yes' ){
                $_POST['ip_exception_mobile_notify'] = 'no';
            }
            if( $post_data['ip_exception_email_notify']!='yes' ){
                $_POST['ip_exception_email_notify'] = 'no';
            }

            $configData['product'] = base64_encode(json_encode(I('post.')));


            /*
            //验证云服务器销售时长
            $serverSaleMonth = $post_data['server_sale_month'];
            if(!empty($serverSaleMonth)){
                foreach($serverSaleMonth as $mon){
                    if(!in_array($mon,[1,2,3,4,5,6,7,8,9,12,24,36]) || !is_numeric($mon)){
                        $this->ajaxReturn(['result' => false, 'text' => '云服务器销售时长设置有误！']);
                    }
                }
            }
            */

            //验证托管服务短信通知
            $idcSendSms = $post_data['idcSendSms'];
            if(!empty($idcSendSms)){
                $mobileArray = explode(',',$idcSendSms);
                foreach ($mobileArray as $mobile){
                    if(!checkMobile($mobile)){
                        $this->ajaxError('托管服务短信通知的号码填写有误');
                    }
                }
            }
            //验证托管服务邮件通知
            $idcSendEmail = $post_data['idcSendEmail'];
            if(!empty($idcSendEmail)){
                $emailArray = explode(',',$idcSendEmail);
                foreach ($emailArray as $emailArray){
                    if(!checkEmail($emailArray)){
                        $this->ajaxError('托管服务邮件通知的邮箱填写有误');
                    }
                }
            }

            //验证控制面板
            $hostPanel = $post_data['hostPanel'];
            if (!empty($hostPanel)) {
                foreach ($hostPanel as $host) {
                    if (!in_array($host, array_keys(HostServerAttr::getHostPanel()))) {
                        $this->ajaxReturn(['result' => false, 'text' => '虚拟主机控制面板开关参数有误！']);
                    }
                }
            }
            $hostDbPanel = $post_data['hostDbPanel'];
            if (!empty($hostDbPanel)) {
                foreach ($hostDbPanel as $host) {
                    if (!in_array($host, array_keys(HostdbServerAttr::getDbPanel()))) {
                        $this->ajaxReturn(['result' => false, 'text' => '数据库控制面板开关参数有误！']);
                    }
                }
            }

            //验证租用服务短信通知
            $leaseSendSms = $post_data['leaseSendSms'];
            if(!empty($leaseSendSms)){
                $mobileArray = explode(',',$leaseSendSms);
                foreach ($mobileArray as $mobile){
                    if(!checkMobile($mobile)){
                        $this->ajaxError('租用服务短信通知的号码填写有误');
                    }
                }
            }
            //验证租用服务邮件通知
            $leaseSendEmail = $post_data['leaseSendEmail'];
            if(!empty($leaseSendEmail)){
                $emailArray = explode(',',$leaseSendEmail);
                foreach ($emailArray as $emailArray){
                    if(!checkEmail($emailArray)){
                        $this->ajaxError('租用服务邮件通知的邮箱填写有误');
                    }
                }
            }

            $log = '';
            if (!empty($post_data)) {
                foreach ($post_data as $key => $p) {
                    if ($key == 'hostPanel') {
                        if (!empty($p)) {
                            $log['虚拟主机控制面板开关'] = '';
                            foreach ($p as $k => $h) {
                                $h_name = HostServerAttr::getHostPanel($h);
                                $log['虚拟主机控制面板开关'] = $log['虚拟主机控制面板开关'] . $h_name . ' ';
                            }
                        }
                    } elseif ($key == 'hostDbPanel') {
                        if (!empty($p)) {
                            $log['数据库控制面板开关'] = '';
                            foreach ($p as $k => $db) {
                                $db_name = HostdbServerAttr::getDbPanel($db);
                                $log['数据库控制面板开关'] = $log['数据库控制面板开关'] . $db_name . ' ';
                            }
                        }
                    } else {
                        $s_key = Setting::getSetting($key);
                        $log[$s_key] = $p;
                    }

                }
            }
            $this->setConfig('', 1, $configData, '产品', $log);
        }
    }

    /**
     * 邮件设置
     */
    public function email()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['email'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $configData['email'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    if ($key != 'emailPassword' && $key != 'testEmail') {
                        $s_key = Setting::getSetting($key);
                        $log[$s_key] = $p;
                    }
                }
            }
            $this->setConfig('', 1, $configData, '邮件', $log);
        }
    }

    /**
     * 短信设置
     */
    public function smg()
    {
        if (IS_POST && IS_AJAX) {
            //验证管理员操作密码
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['smg'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $smgData = I('post.');
            $data1 = [
                'smgSmsbaoUser'       => $smgData['smgSmsbaoUser'],
                'smgSmsbaoPass'      => $smgData['smgSmsbaoPass'],
                'smgSmsbaoSign' => $smgData['smgSmsbaoSign'],
            ];
            $data2 = [
                'smgApiId'       => $smgData['smgApiId'],
                'smgApiKey'      => $smgData['smgApiKey'],
                'smgSignatureMd' => $smgData['smgSignatureMd'],
            ];
            $data3 = [
                'smgAcount'    => $smgData['smgAcount'],
                'smgPassword2' => $smgData['smgPassword2'],
                'smgAuthCode'  => $smgData['smgAuthCode'],
                'smgChannel'   => $smgData['smgChannel'],
                'smgSignature' => $smgData['smgSignature'],
            ];
            if ($smgData['firstChannel'] == 1) {
                $this->checkIsEmpty($data1);
                if ($smgData['reserveChannel'] == 1) {
                    $this->checkIsEmpty($data1);
                }
                if ($smgData['reserveChannel'] == 2) {
                    $this->checkIsEmpty($data2);
                }
                if ($smgData['reserveChannel'] == 3) {
                    $this->checkIsEmpty($data3);
                }
            }

            if ($smgData['firstChannel'] == 2) {
                $this->checkIsEmpty($data2);
                if ($smgData['reserveChannel'] == 1) {
                    $this->checkIsEmpty($data1);
                }
                if ($smgData['reserveChannel'] == 2) {
                    $this->checkIsEmpty($data2);
                }
                if ($smgData['reserveChannel'] == 3) {
                    $this->checkIsEmpty($data3);
                }
            }

            if ($smgData['firstChannel'] == 3) {
                $this->checkIsEmpty($data3);
                if ($smgData['reserveChannel'] == 1) {
                    $this->checkIsEmpty($data1);
                }
                if ($smgData['reserveChannel'] == 2) {
                    $this->checkIsEmpty($data2);
                }
                if ($smgData['reserveChannel'] == 3) {
                    $this->checkIsEmpty($data3);
                }
            }

            $configData['smg'] = base64_encode(json_encode($smgData));
            $log = '';
            if (!empty($smgData)) {
                foreach ($smgData as $key => $p) {
                    if ($key != 'smgApiKey' && $key != 'smgPassword2') {
                        $s_key = Setting::getSetting($key);
                        $log[$s_key] = $p;
                    }
                }
            }
            $this->setConfig('', 1, $configData, '短信', $log);
        }
    }

    private function checkIsEmpty($data)
    {
        if (!is_array($data)) {
            $this->ajaxReturn(['result' => false, 'text' => '数据格式不正确']);
        }
        foreach ($data as $key => $val) {
            if (empty($val)) {
                $errorMsg = substr($key, 3) . ' 不能为空';
                $this->ajaxReturn(['result' => false, 'text' => $errorMsg]);
            }
        }
    }

    /**
     * 接口设置
     */
    public function apiInterface()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['interface'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }
            $configData['interface'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '接口', $log);
        }
    }

    /**
     * 安全设置
     */
    public function safety()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            $_POST['combination'] = implode(',', $_POST['combination']);
            $_POST['safetyVerification'] = implode(',', $_POST['safetyVerification']);

            if (!$this->settingModel->validate(SettingModel::$rules['safety'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }
            $post = I('post.');

            $newConfig = [
                'COOKIE_PREFIX'  => $post['prefixCookie'],
                'URL_MODULE_MAP' => [strval(strtolower($post['adminModule'])) => 'admin'],
            ];

            if (!update_config($newConfig)) {
                $this->ajaxReturn(['result' => false, 'text' => ROOT_CONFIG_PATH . '不可写']);
            }

            R('Admin/Cache/delDirAndFile'); //删除缓存

            $configData['safety'] = base64_encode(json_encode($post));
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '安全', $log);
        }
    }

    /**
     * 上传设置
     */
    public function upload()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['upload'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $configData['upload'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '上传', $log);
        }
    }

    /**
     * 服务器PUSH设置
     */
    public function push()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['push'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }

            $configData['push'] = base64_encode(json_encode(I('post.')));
            $post = I('post.');
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, 'PUSH', $log);
        }
    }

    public function checkApi()
    {
        if (IS_POST && IS_AJAX) {
            $apiID = I('post.apiID');
            $apiKey = I('post.apiKey');
            $apiUrl = I('post.apiURL');
            $bool = !is_int($apiID) ? (ctype_digit($apiID)) : true; //判断是否是整型
            if (!$bool) {
                $this->ajaxReturn(['result' => false, 'text' => '合作商ID必须是整数']);
            }

            if (!$apiUrl) {
                $this->ajaxReturn(['result' => false, 'text' => '接口地址不能为空']);
            }

            if (!$apiKey) {
                $this->ajaxReturn(['result' => false, 'text' => '接口密钥不能为空']);
            }


            $api = new CloudApi($apiID, $apiKey, $apiUrl);
            $result = $api->g2kc2xe0();
            if ($result['code'] == 0) {
                $this->ajaxReturn(['result' => true, 'text' => '接口可用']);
            }
            $this->ajaxReturn(['result' => false, 'text' => $result['message'] . '，错误码：' . $result['code']]);
        }
    }

    public function checkSendEmail()
    {
        if (IS_POST && IS_AJAX) {

            $smtp = I('post.smtp');
            $emailAddress = I('post.emailAddress');
            $emailUsername = I('post.emailUsername');
            $emailPassword = I('post.emailPassword');
            $SMTPSecure = I('post.SMTPSecure');
            $emailPort = I('post.emailPort');
            $testEmail = I('post.testEmail');

            if (!checkEmail($testEmail)) {
                $this->ajaxReturn(['result' => false, 'text' => '测试收件箱格式不正确']);
            }

            $email = new Email($smtp, $emailAddress, $emailUsername, $emailPassword, $SMTPSecure, $emailPort);
            if ($email->send($testEmail, '测试邮件', '这是测试邮件，测试发件。')) {
                $this->ajaxReturn(['result' => true, 'text' => '邮件能正常发送']);
            }
            $this->ajaxReturn(['result' => false, 'text' => '邮件发送失败: ' . $email->error, 'time' => 5]);
        }
    }
    /**
     * 推广设置
     */
    public function promotion()
    {
        if (IS_POST && IS_AJAX) {
            $this->_verifyPassword();
            unset($_POST['password']);

            if (!$this->settingModel->validate(SettingModel::$rules['promotion'])->create()) {
                if ($this->settingModel->getError()) {
                    $this->ajaxReturn(['result' => false, 'text' => $this->settingModel->getError()]);
                }
            }
            $post = I('post.');
            if($post['promotionOpen'] ==1){
                if(empty($post['promotionLevelName'])){
                    $this->ajaxReturn(['result' => false, 'text' => '推广等级名称不能为空']);
                }
                if(empty($post['promotionUpgradeMoney'])){
                    $this->ajaxReturn(['result' => false, 'text' => '购买升级金额不能为空']);
                }
            }
            $configData['promotion'] = base64_encode(json_encode($post));
            $log = '';
            if (!empty($post)) {
                foreach ($post as $key => $p) {
                    $s_key = Setting::getSetting($key);
                    $log[$s_key] = $p;
                }
            }
            $this->setConfig('', 1, $configData, '推广', $log);
        }
    }

}
